/*!
	@file	MyCFGACIUI.cpp
	@author	Copyright (C) 1998-2008 Eastman Kodak Company.
	@author	All rights reserved.
	@date	01-Oct-2008
*/

#include "StdAfx.h"
#include "MyCFGACIUI.h"

//	CMyCFGACIUI
//******************************************************************************
IMPLEMENT_DYNAMIC(CMyCFGACIUI, CDFCFGACIBasicUI)

BEGIN_MESSAGE_MAP(CMyCFGACIUI, CDFCFGACIBasicUI)
	ON_MESSAGE(WM_INITDIALOG, __OnInitDialog)
END_MESSAGE_MAP()

CMyCFGACIUI::CMyCFGACIUI() :CDFCFGACIBasicUI(_T("IDD_MYCFGACIUI"))
{
}

CMyCFGACIUI::~CMyCFGACIUI()
{
}

//	dialog
//------------------------------------------------------------------------------
void CMyCFGACIUI::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
//	DDX_Control(pDX, IDC_CMBCOUNTRY, m_cmbCountry);
	DDX_Control(pDX, IDC_RDLIST, m_rdList);
	DDX_Control(pDX, IDC_RDCHOOSE, m_rdChoose);
	DDX_Control(pDX, IDC_RDLENGTH, m_rdLength);
	DDX_Control(pDX, IDC_ALLOWUSERINPUT, m_btnAllowUserInput);
}

BOOL CMyCFGACIUI::OnInitDialog()
{
	BOOL bRt = CDFCFGACIBasicUI::OnInitDialog();

	return bRt;
}

void CMyCFGACIUI::ToUI()
{
	CMyCFGACIData data;
	data.FromDataBlock(m_config);

	// Set the controls to defaults
	m_rdList.SetCheck( FALSE );
	m_rdChoose.SetCheck( FALSE );
	m_rdLength.SetCheck( FALSE );

	m_btnAllowUserInput.SetCheck( data.m_lAllowUserTyping );

	// and now set based on prevous settings
	switch( data.m_lControlType )
	{
	case MODE_LIST:			// 0
		m_rdList.SetCheck( TRUE ); break;
	case MODE_USER:			// 1
		m_rdChoose.SetCheck( TRUE ); break;
	case MODE_ALLOWTYPING:	// 2
		m_rdLength.SetCheck( TRUE ); break;
	}
}

void CMyCFGACIUI::FromUI()
{
	//Save the configuration to data block m_config.
	CMyCFGACIData data;

	// Get control states
	if( m_rdList.GetCheck() )
		data.m_lControlType = MODE_LIST;		// 0
	else if( m_rdChoose.GetCheck() )
		data.m_lControlType = MODE_USER;		// 1
	else if( m_rdLength.GetCheck() )
		data.m_lControlType = MODE_ALLOWTYPING;	// 2
	else
		data.m_lControlType = MODE_ALLOWTYPING;	// 2

	data.m_lAllowUserTyping = m_btnAllowUserInput.GetCheck();

	data.ToDataBlock(m_config);
}

void CMyCFGACIUI::Refresh()
{

}

// Validate the UI configuration when press "OK" button. if return false, dialog will not disappear
BOOL CMyCFGACIUI::ValidateUI()
{
	// This example does not require any data validation

	return TRUE;
}
