/*!
	@file	MyPlugin.h
	@author	Kelvin Zhong (kelvin.zhong@kodak.com)
	@author	Copyright (C) 1998-2008 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2008-02-02
*/

#pragma once

//	CMyPluginSession
//******************************************************************************
class CMyPlugin;
typedef class TDFShellAPIPluginSession<CMyPlugin> CMyPluginSession;

//	CMyPlugin
//******************************************************************************
class CMyPlugin:public TKCIDXAPIPlugin<CMyPluginSession, CMyPlugin>{
public:
	CMyPlugin();
	~CMyPlugin();

	//!	@name	plugin information
	//@{
public:
	static DFAPI_VERSION_TYPE		g_Version;				//!< plugin version
	static DFAPI_BUILDVERSION_TYPE	g_BuildVersion;			//!< plugin build version
protected:
	virtual void GetPluginInfoEx(LPCTSTR lpszLanguage, CString& strName, CString& strDescription, CString& strCopyright);
	//@}

	//!	@name	DFCFGACI
	//@{
protected:
	virtual CDFCFGACIBasicUI* CreateUI();
	virtual BOOL CFGACI_ValidateConfig(DFAPI_DATA_TYPE& config);
	virtual BOOL CFGACI_GetSupportedUIMode(BOOL& bSupportUI, BOOL& bSupportModalUI);

	virtual BOOL CFGACI_GetUISize(int& nWidth, int& nHeight);
	virtual BOOL CFGACI_ValidateUIConfig();

	virtual BOOL GetErrorMsg(LPCTSTR lpszLanguage, DWORD dwErrCode, CString& strMsg);

	BOOL	AuditUserEntry( CString& sEntry );

	BOOL	m_bValidate;
	//@}

	//!	@name	KCIDXAPI
	//@{
	DFAPI_PLUGIN_DECLARE_STD_INTERFACE(KCIDXAPI_GetEditMode)
	DFAPI_PLUGIN_DECLARE_STD_INTERFACE(KCIDXAPI_GetValueList)
	DFAPI_PLUGIN_DECLARE_STD_INTERFACE(KCIDXAPI_GetValue)
	DFAPI_PLUGIN_DECLARE_STD_INTERFACE(KCIDXAPI_ValidateValue)
	DFAPI_PLUGIN_DECLARE_STD_INTERFACE(KCIDXAPI_FormatOutput)
	//@}
};
