/*!
	@file		SelectStateDlg.cpp
	@author		Copyright (C) 1998-2008 Eastman Kodak Company.
	@author		All rights reserved.
	@date		01-Oct-2008
*/

// SelectStateDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SelectStateDlg.h"


// CSelectStateDlg dialog

IMPLEMENT_DYNAMIC(CSelectStateDlg, CDialog)
CSelectStateDlg::CSelectStateDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectStateDlg::IDD, pParent)
{
}

CSelectStateDlg::~CSelectStateDlg()
{
}

void CSelectStateDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LIST, m_cmbList);
}


BEGIN_MESSAGE_MAP(CSelectStateDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


void CSelectStateDlg::InitList(CStringList& strList)
{
	m_strList.RemoveAll();
	POSITION pos = strList.GetHeadPosition();
	while (pos != NULL) {
		m_strList.AddTail(strList.GetNext(pos));
	}
}

BOOL CSelectStateDlg::GetSelectItem(CString& strItem)
{
	if (m_strSelectItem.IsEmpty()) return FALSE;
	strItem = m_strSelectItem;
	return TRUE;
}

// CSelectStateDlg message handlers
void CSelectStateDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here

	// get and check current selection
	int nSel = m_cmbList.GetCurSel();
	if (nSel == LB_ERR) {
		m_strSelectItem.Empty();
		AfxMessageBox(_T("Please select a state/province/region from the list"));
		return;
	}
	else {
		m_cmbList.GetLBText(nSel, m_strSelectItem);
	}
	
	OnOK();
}

BOOL CSelectStateDlg::OnInitDialog()
{
	// forward
	CDialog::OnInitDialog();

	// initial the combobox with the predefined list.
	POSITION pos = m_strList.GetHeadPosition();
	while (pos != NULL) {
		m_cmbList.AddString(m_strList.GetNext(pos));
	}

	return TRUE;
}
