/*!
	@file	DFCFGACIImpl.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-09-01
*/

#pragma once

#include "DFCFGACI.h"
#include "DFACIImpl.h"

//	CDFCFGACIImpl
//******************************************************************************
class CDFCFGACIImpl:public SDFACIImpl{
	//!	@name	session
	//@{
protected:
	void OnOpenSession(DFAPI_SESSION session){
		ACI_UpdateSession(session, DFCFGACI, this);
	}

	static CDFCFGACIImpl* ACI_CheckSession(DFAPI_SESSION session){
		return (CDFCFGACIImpl*) SDFACIImpl::ACI_CheckSession(session, DFCFGACI);
	}

	static BOOL GetProcAddress(LPCTSTR lpszProcName, LPVOID* lpProcAddress){
		DFAPI_PLUGIN_BEGIN_GPA()
			DFAPI_PLUGIN_GPA(DFCFGACI_GETDEFAULTCONFIG_PROCNAME, CFGACI_GetDefaultConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_VALIDATECONFIG_PROCNAME, CFGACI_ValidateConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_SAVECONFIG_PROCNAME, CFGACI_SaveConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_LOADCONFIG_PROCNAME, CFGACI_LoadConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_SETCURRENTCONFIG_PROCNAME, CFGACI_SetCurrentConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_GETCURRENTCONFIG_PROCNAME, CFGACI_GetCurrentConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_VALIDATECURRENTCONFIG_PROCNAME, CFGACI_ValidateCurrentConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_SAVECURRENTCONFIG_PROCNAME, CFGACI_SaveCurrentConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_LOADCURRENTCONFIG_PROCNAME, CFGACI_LoadCurrentConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_GETSUPPORTEDUIMODE_PROCNAME, CFGACI_GetSupportedUIMode)
			DFAPI_PLUGIN_GPA(DFCFGACI_GETUISIZE_PROCNAME, CFGACI_GetUISize)
			DFAPI_PLUGIN_GPA(DFCFGACI_BEGINUI_PROCNAME, CFGACI_BeginUI)
			DFAPI_PLUGIN_GPA(DFCFGACI_MOVEUI_PROCNAME, CFGACI_MoveUI)
			DFAPI_PLUGIN_GPA(DFCFGACI_UPDATEUI_PROCNAME, CFGACI_UpdateUI)
			DFAPI_PLUGIN_GPA(DFCFGACI_SETUICONFIG_PROCNAME, CFGACI_SetUIConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_GETUICONFIG_PROCNAME, CFGACI_GetUIConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_VALIDATEUICONFIG_PROCNAME, CFGACI_ValidateUIConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_SAVEUICONFIG_PROCNAME, CFGACI_SaveUIConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_LOADUICONFIG_PROCNAME, CFGACI_LoadUIConfig)
			DFAPI_PLUGIN_GPA(DFCFGACI_ENDUI_PROCNAME, CFGACI_EndUI)
			DFAPI_PLUGIN_GPA(DFCFGACI_SHOWMODALUI_PROCNAME, CFGACI_ShowModalUI)
			DFAPI_PLUGIN_GPA(DFCFGACI_HELP_PROCNAME, CFGACI_Help)
		DFAPI_PLUGIN_END_GPA()
	}
	//@}

	//!	@name	CFGACI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_GetDefaultConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_ValidateConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_SaveConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_LoadConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_SetCurrentConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_GetCurrentConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_ValidateCurrentConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_SaveCurrentConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_LoadCurrentConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_GetSupportedUIMode)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_GetUISize)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_BeginUI)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_MoveUI)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_UpdateUI)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_SetUIConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_GetUIConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_ValidateUIConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_SaveUIConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_LoadUIConfig)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_EndUI)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_ShowModalUI)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFCFGACIImpl, CFGACI_Help)
	//@}
};
