/*!
	@file	DFENVACIImpl.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-09-01
*/

#pragma once

#include "DFENVACI.h"
#include "DFACIImpl.h"

//	CDFENVACIImpl
//******************************************************************************
class CDFENVACIImpl:public SDFACIImpl{
	//!	@name	session
	//@{
protected:
	void OnOpenSession(DFAPI_SESSION session){
		ACI_UpdateSession(session, DFENVACI, this);
	}

	static CDFENVACIImpl* ACI_CheckSession(DFAPI_SESSION session){
		return (CDFENVACIImpl*) SDFACIImpl::ACI_CheckSession(session, DFENVACI);
	}

	static BOOL GetProcAddress(LPCTSTR lpszProcName, LPVOID* lpProcAddress){
		DFAPI_PLUGIN_BEGIN_GPA()
			DFAPI_PLUGIN_GPA(DFENVACI_SETPROXYLANGUAGE_PROCNAME, ENVACI_SetProxyLanguage)
			DFAPI_PLUGIN_GPA(DFENVACI_SETAPPROOTPATH_PROCNAME, ENVACI_SetAppRootPath)
			DFAPI_PLUGIN_GPA(DFENVACI_SETPLUGINSSHAREDPATH_PROCNAME, ENVACI_SetPluginsSharedPath)
			DFAPI_PLUGIN_GPA(DFENVACI_SETTEXTVARIABLE_PROCNAME, ENVACI_SetTextVariable)
			DFAPI_PLUGIN_GPA(DFENVACI_GETTEXTVARIABLE_PROCNAME, ENVACI_GetTextVariable)
			DFAPI_PLUGIN_GPA(DFENVACI_SETDATAVARIABLE_PROCNAME, ENVACI_SetDataVariable)
			DFAPI_PLUGIN_GPA(DFENVACI_GETDATAVARIABLE_PROCNAME, ENVACI_GetDataVariable)
			DFAPI_PLUGIN_GPA(DFENVACI_SETHELPERWINDOWHANDLE_PROCNAME, ENVACI_SetHelperWindowHandle)
			DFAPI_PLUGIN_GPA(DFENVACI_GETHELPERWINDOWHANDLE_PROCNAME, ENVACI_GetHelperWindowHandle)
		DFAPI_PLUGIN_END_GPA()
	}
	//@}

	//!	@name	ENVACI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetProxyLanguage)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetAppRootPath)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetPluginsSharedPath)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetTextVariable)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_GetTextVariable)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetDataVariable)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_GetDataVariable)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_SetHelperWindowHandle)
	DFAPI_PLUGIN_STD_INTERFACE_ACI(CDFENVACIImpl, ENVACI_GetHelperWindowHandle)
	//@}
};
