/*!
	@file	DFTSTAPIPlugin.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-09-18
*/

#pragma once

#include "DFTSTAPI.h"
#include "DFShellAPIPlugin.h"
#include "DFENVACIBasicImpl.h"
#include "DFERRACIBasicImpl.h"
#include "DFCFGACIBasicImpl.h"

//	TDFTSTAPIPlugin
//******************************************************************************
template <class SESSIONCLASS, class PLUGINCLASS>
class TDFTSTAPIPlugin:public TDFShellAPIPlugin<SESSIONCLASS, PLUGINCLASS>,
					  public CDFENVACIBasicImpl,
					  public CDFERRACIBasicImpl,
					  public CDFCFGACIBasicImpl{
	//!	@name	plugin information
	//@{
public:
	static DFAPI_TYPEID_TYPE		g_Type;					//!< API type ID
	static DFAPI_VERSION_TYPE		g_APIVersion;			//!< API version
	//@}

	//!	@name	session
	//@{
public:
	virtual void OnOpenSession(DFAPI_SESSION session);
	virtual void OnCloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	shell API
	//@{
public:
	virtual BOOL GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress);
	virtual void CloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	DFTSTAPI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DFTSTAPI_ExampleCall)
	//@}
};

//******************************************************************************
#include "DFTSTAPIPlugin.inl"