/*!
	@file	DFTSTAPIPlugin.inl
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-09-18
*/

#pragma once

#include "DFTSTAPIPlugin.h"

//	TDFTSTAPIPlugin
//******************************************************************************

//	plugin information
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_TYPEID_TYPE TDFTSTAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_Type(DFTSTAPI);

template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_VERSION_TYPE TDFTSTAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_APIVersion(DFTSTAPI_VERSION);

//	session
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
void TDFTSTAPIPlugin<SESSIONCLASS, PLUGINCLASS>::OnOpenSession(DFAPI_SESSION session)
{
	//DFENVACI
	CDFENVACIImpl::OnOpenSession(session);

	//DFERRACI
	CDFERRACIImpl::OnOpenSession(session);

	//DFCFGACI
	CDFCFGACIImpl::OnOpenSession(session);
}

//	shell API
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
BOOL TDFTSTAPIPlugin<SESSIONCLASS, PLUGINCLASS>::GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress)
{
	DFAPI_PLUGIN_BEGIN_GPA()
		//DFTSTAPI
		DFAPI_PLUGIN_GPA(DFTSTAPI_EXAMPLECALL_PROCNAME, DFTSTAPI_ExampleCall)

		//DFENVACI
		if (CDFENVACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFERRACI
		if (CDFERRACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFCFGACI
		if (CDFCFGACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
	DFAPI_PLUGIN_END_GPA()
}
