/*!
	@file	DIIDFAPI.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-05
*/

#pragma once

#include "DFShellAPI.h"

//	DIIDFAPI
//******************************************************************************
#define	DIIDFAPI											0x0000C294

//	DIIDFAPI_VERSION
//******************************************************************************
#define	DIIDFAPI_VERSION									0x00010000

//	DIIDFAPI_MODEMASK	
//******************************************************************************
#define	DIIDFAPI_MODEMASK_INDEX_BATCH						0x00000001		//!< support batch level index 
#define	DIIDFAPI_MODEMASK_INDEX_DOCUMENT					0x00000002		//!< support document level index
#define	DIIDFAPI_MODEMASK_INDEX_IMAGE						0x00000004		//!< support image level index

//	DIIDFAPI_GETDEFAULTFILEEXT
//******************************************************************************
#define	DIIDFAPI_GETDEFAULTFILEEXT_PROCNAME					_T("DIIDFAPI.GetDefaultFileExt")
struct DIIDFAPI_GETDEFAULTFILEEXT_PARAM{
	DFAPI_TEXT32_TYPE				szFileExt;				//!< [out]: default file extension, eg. ".dat"
};

//	DIIDFAPI_GETDEFAULTFILEICON
//******************************************************************************
#define	DIIDFAPI_GETDEFAULTFILEICON_PROCNAME				_T("DIIDFAPI.GetDefaultFileIcon")
struct DIIDFAPI_GETDEFAULTFILEICON_PARAM{
	__int32							nDesiredWidth;			//!< [in]: desired width of the icon
	__int32							nDesiredHeight;			//!< [in]: desired height of the icon
	HICON							hIcon;					//!< [out]: default file icon, invoker will be responsible for releasing
};

//	DIIDFAPI_RESET
//******************************************************************************
#define	DIIDFAPI_RESET_PROCNAME								_T("DIIDFAPI.Reset")
struct DIIDFAPI_RESET_PARAM{
};

//	DIIDFAPI_BEGINDATASET
//******************************************************************************
#define	DIIDFAPI_BEGINDATASET_PROCNAME						_T("DIIDFAPI.BeginDataSet")
struct DIIDFAPI_BEGINDATASET_PARAM{
	DFAPI_TEXTPATH_TYPE				szFilePath;				//!< [in]: data set file path
	BOOL							bInitializeDataSet;		//!< [in]: flag to initialize data set
};

//	DIIDFAPI_BEGINHEAD
//******************************************************************************
#define	DIIDFAPI_BEGINHEAD_PROCNAME							_T("DIIDFAPI.BeginHead")
struct DIIDFAPI_BEGINHEAD_PARAM{
	DFAPI_TEXT128_TYPE				szLevelName;			//!< [in]: level name
};

//	DIIDFAPI_ADDHEADCOLUMN
//******************************************************************************
#define	DIIDFAPI_ADDHEADCOLUMN_PROCNAME						_T("DIIDFAPI.AddHeadColumn")
struct DIIDFAPI_ADDHEADCOLUMN_PARAM{
	DFAPI_TEXT128_TYPE				szLevelName;			//!< [in]: level name
	DFAPI_TEXT128_TYPE				szColumnName;			//!< [in]: column name
};

//	DIIDFAPI_ENDHEAD
//******************************************************************************
#define	DIIDFAPI_ENDHEAD_PROCNAME							_T("DIIDFAPI.EndHead")
struct DIIDFAPI_ENDHEAD_PARAM{
};

//	DIIDFAPI_BEGINRECORD
//******************************************************************************
#define	DIIDFAPI_BEGINRECORD_PROCNAME						_T("DIIDFAPI.BeginRecord")
struct DIIDFAPI_BEGINRECORD_PARAM{
	DFAPI_TEXT128_TYPE				szLevelName;			//!< [in]: level name
};

//	DIIDFAPI_ADDRECORDCOLUMN
//******************************************************************************
#define	DIIDFAPI_ADDRECORDCOLUMN_PROCNAME					_T("DIIDFAPI.AddRecordColumn")
struct DIIDFAPI_ADDRECORDCOLUMN_PARAM{
	DFAPI_TEXT128_TYPE				szLevelName;			//!< [in]: level name
	DFAPI_TEXT128_TYPE				szColumnName;			//!< [in]: column name
	DFAPI_TEXT4096_TYPE				szColumnValue;			//!< [in]: column value
};

//	DIIDFAPI_ENDRECORD
//******************************************************************************
#define	DIIDFAPI_ENDRECORD_PROCNAME							_T("DIIDFAPI.EndRecord")
struct DIIDFAPI_ENDRECORD_PARAM{
};

//	DIIDFAPI_ENDDATASET
//******************************************************************************
#define	DIIDFAPI_ENDDATASET_PROCNAME						_T("DIIDFAPI.EndDataSet")
struct DIIDFAPI_ENDDATASET_PARAM{
};

//	DFENVACI - Variables
//******************************************************************************
#define DIIDFAPI_TV_ITEM_DELIMITER							0		//!< item delimiter - encloser
#define DIIDFAPI_TV_FIELD_DELIMITER							1		//!< field delimiter - seperator

#define DIIDFAPI_DV_INCLUDE_HEADER							0		//!< include header mode
#define	DIIDFAPI_DV_SUPPORTEDMODE							1		//!< supported mode, typically readonly
#define	DIIDFAPI_DV_CURRENTMODE								2		//!< current mode
