/*!
	@file	DIIDFAPIPlugin.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-05
*/

#pragma once

#include "DIIDFAPI.h"
#include "DFShellAPIPlugin.h"
#include "DFENVACIBasicImpl.h"
#include "DFERRACIBasicImpl.h"
#include "DFCFGACIBasicImpl.h"

//	TDIIDFAPIPlugin
//******************************************************************************
template <class SESSIONCLASS, class PLUGINCLASS>
class TDIIDFAPIPlugin:public TDFShellAPIPlugin<SESSIONCLASS, PLUGINCLASS>,
					  public CDFENVACIBasicImpl,
					  public CDFERRACIBasicImpl,
					  public CDFCFGACIBasicImpl{
	//!	@name	plugin information
	//@{
public:
	static DFAPI_TYPEID_TYPE		g_Type;					//!< API type ID
	static DFAPI_VERSION_TYPE		g_APIVersion;			//!< API version
	//@}

	//!	@name	session
	//@{
public:
	virtual void OnOpenSession(DFAPI_SESSION session);
	virtual void OnCloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	shell API
	//@{
public:
	virtual BOOL GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress);
	virtual void CloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	DIIDFAPI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_GetDefaultFileExt)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_GetDefaultFileIcon)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_Reset)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_BeginDataSet)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_BeginHead)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_AddHeadColumn)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_EndHead)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_BeginRecord)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_AddRecordColumn)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_EndRecord)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, DIIDFAPI_EndDataSet)
	//@}

	//! @name DFENVACI - variables
	//@{
protected:
	DFENVACI_PLUGIN_TV_GET(DIIDFAPI_TV_ITEM_DELIMITER,TV_GetItemDelimiter)
	DFENVACI_PLUGIN_TV_GET(DIIDFAPI_TV_FIELD_DELIMITER,TV_GetFieldDelimiter)
	DFENVACI_PLUGIN_DV_GET(DIIDFAPI_DV_INCLUDE_HEADER,DV_GetIncludeHeader,DWORD&)
	DFENVACI_PLUGIN_DV_SET(DIIDFAPI_DV_SUPPORTEDMODE, DV_SetSupportedMode, DWORD)
	DFENVACI_PLUGIN_DV_GET(DIIDFAPI_DV_CURRENTMODE, DV_GetCurrentMode, DWORD&)
	//@}
};

//******************************************************************************
#include "DIIDFAPIPlugin.inl"