/*!
	@file	DIIDFAPIPlugin.inl
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2006 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-05
*/

#pragma once

#include "DIIDFAPIPlugin.h"

//	TDIIDFAPIPlugin
//******************************************************************************

//	plugin information
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_TYPEID_TYPE TDIIDFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_Type(DIIDFAPI);

template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_VERSION_TYPE TDIIDFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_APIVersion(DIIDFAPI_VERSION);

//	session
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
void TDIIDFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::OnOpenSession(DFAPI_SESSION session)
{
	//DFENVACI
	CDFENVACIImpl::OnOpenSession(session);

	//DFERRACI
	CDFERRACIImpl::OnOpenSession(session);

	//DFCFGACI
	CDFCFGACIImpl::OnOpenSession(session);
}

//	shell API
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
BOOL TDIIDFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress)
{
	DFAPI_PLUGIN_BEGIN_GPA()
		//DIIDFAPI
		DFAPI_PLUGIN_GPA(DIIDFAPI_GETDEFAULTFILEEXT_PROCNAME, DIIDFAPI_GetDefaultFileExt)
		DFAPI_PLUGIN_GPA(DIIDFAPI_GETDEFAULTFILEICON_PROCNAME, DIIDFAPI_GetDefaultFileIcon)
		DFAPI_PLUGIN_GPA(DIIDFAPI_RESET_PROCNAME, DIIDFAPI_Reset)
		DFAPI_PLUGIN_GPA(DIIDFAPI_BEGINDATASET_PROCNAME, DIIDFAPI_BeginDataSet)
		DFAPI_PLUGIN_GPA(DIIDFAPI_BEGINHEAD_PROCNAME, DIIDFAPI_BeginHead)
		DFAPI_PLUGIN_GPA(DIIDFAPI_ADDHEADCOLUMN_PROCNAME, DIIDFAPI_AddHeadColumn)
		DFAPI_PLUGIN_GPA(DIIDFAPI_ENDHEAD_PROCNAME, DIIDFAPI_EndHead)
		DFAPI_PLUGIN_GPA(DIIDFAPI_BEGINRECORD_PROCNAME, DIIDFAPI_BeginRecord)
		DFAPI_PLUGIN_GPA(DIIDFAPI_ADDRECORDCOLUMN_PROCNAME, DIIDFAPI_AddRecordColumn)
		DFAPI_PLUGIN_GPA(DIIDFAPI_ENDRECORD_PROCNAME, DIIDFAPI_EndRecord)
		DFAPI_PLUGIN_GPA(DIIDFAPI_ENDDATASET_PROCNAME, DIIDFAPI_EndDataSet)

		//DFENVACI
		if (CDFENVACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFERRACI
		if (CDFERRACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFCFGACI
		if (CDFCFGACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
	DFAPI_PLUGIN_END_GPA()
}
