/*!
	@file	DIIMFAPIPlugin.inl
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-18
*/

#pragma once

#include "DIIMFAPIPlugin.h"

//	TDIIMFAPIPlugin
//******************************************************************************

//	plugin information
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_TYPEID_TYPE TDIIMFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_Type(DIIMFAPI);

template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_VERSION_TYPE TDIIMFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_APIVersion(DIIMFAPI_VERSION);

//	session
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
void TDIIMFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::OnOpenSession(DFAPI_SESSION session)
{
	//DFENVACI
	CDFENVACIImpl::OnOpenSession(session);

	//DFERRACI
	CDFERRACIImpl::OnOpenSession(session);

	//DFCFGACI
	CDFCFGACIImpl::OnOpenSession(session);
}

//	shell API
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
BOOL TDIIMFAPIPlugin<SESSIONCLASS, PLUGINCLASS>::GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress)
{
	DFAPI_PLUGIN_BEGIN_GPA()
		//DIIMFAPI
		DFAPI_PLUGIN_GPA(DIIMFAPI_GETDEFAULTFILEEXT_PROCNAME, DIIMFAPI_GetDefaultFileExt)
		DFAPI_PLUGIN_GPA(DIIMFAPI_GETDEFAULTFILEICON_PROCNAME, DIIMFAPI_GetDefaultFileIcon)
		DFAPI_PLUGIN_GPA(DIIMFAPI_RESET_PROCNAME, DIIMFAPI_Reset)
		DFAPI_PLUGIN_GPA(DIIMFAPI_BEGINIMAGESET_PROCNAME, DIIMFAPI_BeginImageSet)
		DFAPI_PLUGIN_GPA(DIIMFAPI_ADDIMAGEFILE_PROCNAME, DIIMFAPI_AddImageFile)
		DFAPI_PLUGIN_GPA(DIIMFAPI_ADDIMAGE_PROCNAME, DIIMFAPI_AddImage)
		DFAPI_PLUGIN_GPA(DIIMFAPI_ENDIMAGESET_PROCNAME, DIIMFAPI_EndImageSet)
		DFAPI_PLUGIN_GPA(DIIMFAPI_LEGACYDATAIO_PROCNAME, DIIMFAPI_LegacyDataIO)

		//DFENVACI
		if (CDFENVACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFERRACI
		if (CDFERRACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFCFGACI
		if (CDFCFGACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
	DFAPI_PLUGIN_END_GPA()
}
