/*!
	@file	KCBANAPI.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-11
*/

#pragma once

#include "DFShellAPI.h"

//	KCBANAPI
//******************************************************************************
#define	KCBANAPI											0x00005F83

//	KCBANAPI_VERSION
//******************************************************************************
#define	KCBANAPI_VERSION									0x00010000

//	KCBANAPI_SETPARAMETERS
//******************************************************************************
#define	KCBANAPI_SETPARAMETERS_PROCNAME						_T("KCBANAPI.SetParameters")
struct KCBANAPI_SETPARAMETERS_PARAM{
	DFAPI_TEXT4096_TYPE				szParameters;			//!< [in]: parameters
};

//	KCBANAPI_CREATEBATCHNAME
//******************************************************************************
#define	KCBANAPI_CREATEBATCHNAME_PROCNAME					_T("KCBANAPI.CreateBatchName")
struct KCBANAPI_CREATEBATCHNAME_PARAM{
	DFAPI_TEXT128_TYPE				szBatchName;			//!< [in,out]: batch name.  assumption:  szBatchName = szFixString + szBatchCount, eg szBatchName = "mybatch001", szFixString = "mybatch",  szBatchCount = "001"
	DFAPI_TEXT128_TYPE				szFixString;			//!< [out] fixed string in batch name.
	DFAPI_TEXT128_TYPE				szBatchCount;			//! [out] batch counter in batch name if possible, used for updating batch counter manually
};

// DFENVACI - variables
//**************************************************************************************
#define KCBANAPI_DV_BATCHCOUNTER						0