/*!
	@file	KCBANAPIPlugin.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-11
*/

#pragma once

#include "KCBANAPI.h"
#include "DFShellAPIPlugin.h"
#include "DFENVACIBasicImpl.h"
#include "DFERRACIBasicImpl.h"
#include "DFCFGACIBasicImpl.h"

//	TKCBANAPIPlugin
//******************************************************************************
template <class SESSIONCLASS, class PLUGINCLASS>
class TKCBANAPIPlugin:public TDFShellAPIPlugin<SESSIONCLASS, PLUGINCLASS>,
					  public CDFENVACIBasicImpl,
					  public CDFERRACIBasicImpl,
					  public CDFCFGACIBasicImpl{
	//!	@name	plugin information
	//@{
public:
	static DFAPI_TYPEID_TYPE		g_Type;					//!< API type ID
	static DFAPI_VERSION_TYPE		g_APIVersion;			//!< API version
	//@}

	//!	@name	session
	//@{
public:
	virtual void OnOpenSession(DFAPI_SESSION session);
	virtual void OnCloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	shell API
	//@{
public:
	virtual BOOL GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress);
	virtual void CloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	KCBANAPI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCBANAPI_SetParameters)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCBANAPI_CreateBatchName)
	//@}
	//!	@name	DFENVACI - variables
	//@{
protected:
	DFENVACI_PLUGIN_DV_GET(KCBANAPI_DV_BATCHCOUNTER, DV_GetBatchCounter, long&)
	DFENVACI_PLUGIN_DV_SET(KCBANAPI_DV_BATCHCOUNTER, DV_SetBatchCounter, long)
	//@}
};

//******************************************************************************
#include "KCBANAPIPlugin.inl"
