/*!
	@file	KCBANAPIPlugin.inl
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-11
*/

#pragma once

#include "KCBANAPIPlugin.h"

//	TKCBANAPIPlugin
//******************************************************************************

//	plugin information
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_TYPEID_TYPE TKCBANAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_Type(KCBANAPI);

template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_VERSION_TYPE TKCBANAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_APIVersion(KCBANAPI_VERSION);

//	session
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
void TKCBANAPIPlugin<SESSIONCLASS, PLUGINCLASS>::OnOpenSession(DFAPI_SESSION session)
{
	//DFENVACI
	CDFENVACIImpl::OnOpenSession(session);

	//DFERRACI
	CDFERRACIImpl::OnOpenSession(session);

	//DFCFGACI
	CDFCFGACIImpl::OnOpenSession(session);
}

//	shell API
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
BOOL TKCBANAPIPlugin<SESSIONCLASS, PLUGINCLASS>::GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress)
{
	DFAPI_PLUGIN_BEGIN_GPA()
		//KCBANAPI
		DFAPI_PLUGIN_GPA(KCBANAPI_SETPARAMETERS_PROCNAME, KCBANAPI_SetParameters)
		DFAPI_PLUGIN_GPA(KCBANAPI_CREATEBATCHNAME_PROCNAME, KCBANAPI_CreateBatchName)

		//DFENVACI
		if (CDFENVACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFERRACI
		if (CDFERRACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFCFGACI
		if (CDFCFGACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
	DFAPI_PLUGIN_END_GPA()
}
