/*!
	@file	KCIDXAPI.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-11-01
*/

#pragma once

#include "DFShellAPI.h"

//	KCIDXAPI
//******************************************************************************
#define	KCIDXAPI											0x000044D4

//	KCIDXAPI_VERSION
//******************************************************************************
#define	KCIDXAPI_VERSION									0x00010000

//	KCIDXAPI_EDITMODE
//******************************************************************************
#define	KCIDXAPI_EDITMODE_ALLOWTYPING						0x8000		//!< allow user to type the value directly
#define	KCIDXAPI_EDITMODE_LIST								0x0001		//!< provide a list for user to pick up value from
#define	KCIDXAPI_EDITMODE_USER								0x0002		//!< provide a way for user to get a value by calling plugin

//	KCIDXAPI_GETEDITMODE
//******************************************************************************
#define	KCIDXAPI_GETEDITMODE_PROCNAME						_T("KCIDXAPI.GetEditMode")
struct KCIDXAPI_GETEDITMODE_PARAM{
	WORD							wMode;					//!< [out]: edit mode
};

//	KCIDXAPI_GETVALUELIST
//******************************************************************************
#define	KCIDXAPI_GETVALUELIST_PROCNAME						_T("KCIDXAPI.GetValueList")
struct KCIDXAPI_GETVALUELIST_PARAM{
	DFAPI_DATA_TYPE					ValueList;				//!< [out]: value list items, separated by "\r\n"
};

//	KCIDXAPI_GETVALUE
//******************************************************************************
#define	KCIDXAPI_GETVALUE_PROCNAME							_T("KCIDXAPI.GetValue")
struct KCIDXAPI_GETVALUE_PARAM{
	DFAPI_TEXT4096_TYPE				szValue;				//!< [out]: value
};

//	KCIDXAPI_VALIDATEVALUE
//******************************************************************************
#define	KCIDXAPI_VALIDATEVALUE_PROCNAME						_T("KCIDXAPI.ValidateValue")
struct KCIDXAPI_VALIDATEVALUE_PARAM{
	DFAPI_TEXT4096_TYPE				szValue;				//!< [in]: value
	DFAPI_TEXT4096_TYPE				szValidatedValue;		//!< [out]: value
	int								nValidFor;				//!< [in]: validate value for which action
	BOOL							bIsValid;				//!< [out]: validation result, nonzero is valid
};

//	KCIDXAPI_FORMATOUTPUT
//******************************************************************************
#define	KCIDXAPI_FORMATOUTPUT_PROCNAME						_T("KCIDXAPI.FormatOutput")
struct KCIDXAPI_FORMATOUTPUT_PARAM{
	DFAPI_TEXT4096_TYPE				szInputValue;			//!< [in]: input value
	DFAPI_TEXT4096_TYPE				szOutputValue;			//!< [out]: output value
};
