/*!
	@file	KCIDXAPIPlugin.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-11-01
*/

#pragma once

#include "KCIDXAPI.h"
#include "DFShellAPIPlugin.h"
#include "DFENVACIBasicImpl.h"
#include "DFERRACIBasicImpl.h"
#include "DFCFGACIBasicImpl.h"

//	TKCIDXAPIPlugin
//******************************************************************************
template <class SESSIONCLASS, class PLUGINCLASS>
class TKCIDXAPIPlugin:public TDFShellAPIPlugin<SESSIONCLASS, PLUGINCLASS>,
					  public CDFENVACIBasicImpl,
					  public CDFERRACIBasicImpl,
					  public CDFCFGACIBasicImpl{
	//!	@name	plugin information
	//@{
public:
	static DFAPI_TYPEID_TYPE		g_Type;					//!< API type ID
	static DFAPI_VERSION_TYPE		g_APIVersion;			//!< API version
	//@}

	//!	@name	session
	//@{
public:
	virtual void OnOpenSession(DFAPI_SESSION session);
	virtual void OnCloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	shell API
	//@{
public:
	virtual BOOL GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress);
	virtual void CloseSession(DFAPI_SESSION session){}
	//@}

	//!	@name	KCIDXAPI
	//@{
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCIDXAPI_GetEditMode)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCIDXAPI_GetValueList)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCIDXAPI_GetValue)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCIDXAPI_ValidateValue)
	DFAPI_PLUGIN_STD_INTERFACE(PLUGINCLASS, KCIDXAPI_FormatOutput)
	//@}
};

//******************************************************************************
#include "KCIDXAPIPlugin.inl"
