/*!
	@file	KCIDXAPIPlugin.inl
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-11-01
*/

#pragma once

#include "KCIDXAPIPlugin.h"

//	TKCIDXAPIPlugin
//******************************************************************************

//	plugin information
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_TYPEID_TYPE TKCIDXAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_Type(KCIDXAPI);

template <class SESSIONCLASS, class PLUGINCLASS>
DFAPI_VERSION_TYPE TKCIDXAPIPlugin<SESSIONCLASS, PLUGINCLASS>::g_APIVersion(KCIDXAPI_VERSION);

//	session
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
void TKCIDXAPIPlugin<SESSIONCLASS, PLUGINCLASS>::OnOpenSession(DFAPI_SESSION session)
{
	//DFENVACI
	CDFENVACIImpl::OnOpenSession(session);

	//DFERRACI
	CDFERRACIImpl::OnOpenSession(session);

	//DFCFGACI
	CDFCFGACIImpl::OnOpenSession(session);
}

//	shell API
//------------------------------------------------------------------------------
template <class SESSIONCLASS, class PLUGINCLASS>
BOOL TKCIDXAPIPlugin<SESSIONCLASS, PLUGINCLASS>::GetProcAddress(DFAPI_SESSION session, LPCTSTR lpszProcName, LPVOID* lpProcAddress)
{
	DFAPI_PLUGIN_BEGIN_GPA()
		//KCIDXAPI
		DFAPI_PLUGIN_GPA(KCIDXAPI_GETEDITMODE_PROCNAME, KCIDXAPI_GetEditMode)
		DFAPI_PLUGIN_GPA(KCIDXAPI_GETVALUELIST_PROCNAME, KCIDXAPI_GetValueList)
		DFAPI_PLUGIN_GPA(KCIDXAPI_GETVALUE_PROCNAME, KCIDXAPI_GetValue)
		DFAPI_PLUGIN_GPA(KCIDXAPI_VALIDATEVALUE_PROCNAME, KCIDXAPI_ValidateValue)
		DFAPI_PLUGIN_GPA(KCIDXAPI_FORMATOUTPUT_PROCNAME, KCIDXAPI_FormatOutput)

		//DFENVACI
		if (CDFENVACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
		
		//DFERRACI
		if (CDFERRACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;

		//DFCFGACI
		if (CDFCFGACIImpl::GetProcAddress(lpszProcName, lpProcAddress)) return TRUE;
	DFAPI_PLUGIN_END_GPA()
}
