/*!
	@file	KCMSLAPI.h
	@author	Max Wu (max.wu@kodak.com)
	@author	Copyright (C) 1998-2007 Eastman Kodak Company.
	@author	All rights reserved.
	@date	2006-10-16
*/

#pragma once

#include "DFShellAPI.h"

//	KCMSLAPI
//******************************************************************************
#define	KCMSLAPI											0x0000CFC8

//	KCMSLAPI_VERSION
//******************************************************************************
#define	KCMSLAPI_VERSION									0x00010000

//	Event ID
//******************************************************************************
//Application 
#define	KCMSLAPI_EVENT_LOGIN								0x00001001
#define	KCMSLAPI_EVENT_LOGOFF								0x00001002
#define	KCMSLAPI_EVENT_STARTSCANNING						0x00001003
#define	KCMSLAPI_EVENT_STOPSCANNING							0x00001004
#define KCMSLAPI_EVENT_AUTOSTOP								0x00001005
#define KCMSLAPI_EVENT_CAPTURESTART							0x00001006
#define KCMSLAPI_EVENT_CAPTURESHUTDOWN						0x00001007
#define KCMSLAPI_EVENT_CHANGESTATION						0x00001008

//batch level
#define	KCMSLAPI_EVENT_NEWBATCH								0x00002001
#define	KCMSLAPI_EVENT_OPENBATCH							0x00002002
#define	KCMSLAPI_EVENT_CLOSEBATCH							0x00002003
#define	KCMSLAPI_EVENT_DELETEBATCH							0x00002004
#define KCMSLAPI_EVENT_CLEARBATCH							0x00002005
#define KCMSLAPI_EVENT_FINISHBATCH							0x00002006
#define KCMSLAPI_EVENT_ATTATCHIMG							0x00002007
#define KCMSLAPI_EVENT_BATCHSEPARATION						0x00002008
#define KCMSLAPI_EVENT_ATTATCH								0x00002009
#define KCMSLAPI_EVENT_REVIEW								0x00002010
#define KCMSLAPI_EVENT_RENAMEBATCH							0x00002011


//document level
#define KCMSLAPI_EVENT_NEWDOC								0x00003001
#define KCMSLAPI_EVENT_DELDOC								0x00003002
#define KCMSLAPI_EVENT_DOCSEPARATION						0x00003003
#define KCMSLAPI_EVENT_DOCSPLIT								0x00003004
#define KCMSLAPI_EVENT_DOCMERGE								0x00003005

// Page level
#define KCMSLAPI_EVENT_PAGERESCAN							0x00004002
#define KCMSLAPI_EVENT_PAGEINSERT							0x00004003
#define KCMSLAPI_EVENT_PAGEIMPORT							0x00004004

//image level
#define KCMSLAPI_EVENT_IMAGECROP							0x00005000
#define KCMSLAPI_EVENT_IMAGEMANUDELETE						0x00005001  //!< Image Manual delete
#define KCMSLAPI_EVENT_IMAGEAUTOMERGE						0x00005002  
#define KCMSLAPI_EVENT_IMAGEAUTOSPLIT						0x00005003	//!< Image Autotaticaially delete
#define KCMSLAPI_EVENT_IMAGECOPY							0x00005005
#define KCMSLAPI_EVENT_IMAGEBLANK							0x00005006
#define KCMSLAPI_EVENT_IMAGEROTATE							0x00005007
#define KCMSLAPI_EVENT_IMAGEAUTODELETE						0X00005008    //!< Image Delete auotomaticially
#define KCMSLAPI_EVENT_IMAGEIMPORT							0x00005009


//auto stop reason code
#define	KCMSLAPI_STOPREASON_PAGECOUNTEXCEED					0x00000001   //!< Batch Page Count exceeded

//	KCMSLAPI_LOGEVENT
//******************************************************************************
#define	KCMSLAPI_LOGEVENT_PROCNAME							_T("KCMSLAPI.LogEvent")
struct KCMSLAPI_LOGEVENT_PARAM{
	DFAPI_DATETIME_TYPE				dtTimeStamp;			//!< [in]: time stamp
	DWORD							dwEventID;				//!< [in]: event ID
	DFAPI_TEXT128_TYPE				szUserName;				//!< [in]: user name
	DFAPI_TEXT128_TYPE				szWorkstationName;		//!< [in]: workstation name
	DFAPI_TEXTPATH_TYPE				szJobRootDir;			//!< [in]: job root directory
	DFAPI_TEXT128_TYPE				szJobName;				//!< [in]: job name
	DFAPI_TEXT128_TYPE				szBatchName;			//!< [in]: batch name
	DWORD							dwDocumentID;			//!< [in]: document ID
	DWORD							dwPageID;				//!< [in]: page ID
	DWORD							dwImageID;				//!< [in]: image ID
	DFAPI_TEXT1024_TYPE				szParameters;			//!< [in]: parameters
};
